<template>
  <div
    ref="root"
    class="round-options"
    :class="{ 'round-options--2-per-row': optionsPerLine === 2, 'round-options--big': big }">
    <div
      v-for="option in calculatedOptions"
      :key="option.key"
      class="round-option"
      :class="{
        'round-option--selected': selectedOptionKeys.includes(option.key),
      }"
      @click="onSelect(option)">
      <div class="round-option__wrapper">
        <img
          :src="require(`~/assets/images/round-option-${option.selectedImage}`)"
          class="round-option__image round-option__image--selected" />
        <img :src="require(`~/assets/images/round-option-${option.defaultImage}`)" class="round-option__image" />
        <img src="~assets/images/round-option-border.svg" class="round-option__border" />
      </div>
      <span class="round-option__title">{{ option.title }}</span>
    </div>
  </div>
</template>

<script>
  export default {
    props: {
      options: Array,
      value: [String, Array],

      optionsPerLine: {
        type: Number,
        default: 2,
      },

      multiple: Boolean,
      big: Boolean,
    },

    data() {
      return {
        selectedOptionKeys: this.multiple ? this.value || [] : [this.value],
      };
    },

    computed: {
      calculatedOptions() {
        return this.options.map((option) => {
          return { ...option, selectedImage: option.selectedImage || option.defaultImage };
        });
      },
    },

    methods: {
      onSelect(option) {
        if (this.multiple) {
          let selectedOptionIndex = this.selectedOptionKeys.indexOf(option.key);

          if (selectedOptionIndex > -1) {
            this.selectedOptionKeys.splice(selectedOptionIndex, 1);
          } else {
            this.selectedOptionKeys.push(option.key);
          }

          this.$emit('input', this.selectedOptionKeys);
          return;
        }

        this.selectedOptionKeys = [option.key];
        this.$emit('input', this.selectedOptionKeys[0] || null);
      },
    },
  };
</script>

<style lang="scss">
  .round-options {
    margin-bottom: rs(-13px);
    display: flex;
    flex-wrap: wrap;
    width: 100%;
    align-items: flex-start;
    justify-content: center;
    padding: 0 5%;

    &--2-per-row {
      padding: 0 20%;
    }
  }

  .round-option {
    position: relative;
    flex-grow: 1;
    width: math.div(100%, 3);
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    cursor: pointer;
    margin-bottom: rs(13px);
  }

  .round-option__wrapper {
    position: relative;
    width: rs(50px);
  }

  .round-options.round-options--big .round-option__wrapper {
    width: rs(70px);
  }

  .round-option__image {
    width: 100%;
  }

  .round-option:not(.round-option--selected) .round-option__image.round-option__image--selected {
    display: none;
  }

  .round-option--selected .round-option__image:not(.round-option__image--selected) {
    display: none;
  }

  .round-option__border {
    position: absolute;
    z-index: 1;
    top: rs(-4px);
    right: rs(-4px);
    bottom: rs(-4px);
    left: rs(-4px);
    width: calc(100% + 8px);
  }

  .round-option:not(.round-option--selected) .round-option__border {
    display: none;
  }

  .round-option__title {
    font-size: rf(14px);
    line-height: 120%;
    font-weight: bold;
    text-align: center;
  }
</style>
